cd /etc/kubernetes/pki
umask 077
openssl genrsa -out $1.key 2048
openssl req -new -key $1.key -out $1.csr -subj "/CN=$1" 
openssl x509 -req -in $1.csr -CA ./ca.crt -CAkey ./ca.key -CAcreateserial -out $1.crt -days 365
openssl x509 -in $1.crt -text -noout
kubectl config set-credentials $1 --client-certificate=./$1.crt --client-key=./$1.key --embed-certs=true
kubectl config set-context $1@kubernetes --cluster=kubernetes --user=$1

kubectl create clusterrole cr_reader --verb=get,list,watch --resource=*

if [[ $1 = sysadm ]];
then
	kubectl create clusterrole cr_sysadm --verb=* --resource=*.* 
	kubectl create clusterrolebinding crb_sysadm --clusterrole=cr_sysadm --user=sysadm
elif [[ $1 = secadm ]];
then
	kubectl create clusterrole cr_secadm --verb=get,list,watch,patch --resource=namespace,node 
	kubectl create clusterrolebinding crb_secadm1 --clusterrole=cr_reader --user=secadm
	kubectl create clusterrolebinding crb_secadm2 --clusterrole=cr_secadm --user=secadm
elif [[ $1 = auditadm ]];
then
	kubectl create clusterrolebinding crb_auditadm --clusterrole=cr_reader --user=auditadm
else
	kubectl create clusterrolebinding crb_$1 --clusterrole=cr_reader --user=$1
fi

exit 0
